//import javax.media.opengl.*;
//import com.sun.opengl.util.*;
import processing.opengl.*;
//
////add gui after i actually make the switch from p3d to OPENGL
String Mode = OPENGL;
String RMode = OPENGL;  // Rendering mode, mean do we use processing function to display or GL context functions
//String RMode = P3D;  // Rendering mode, mean do we use processing function to display or GL context functions
PFont fontA;
boolean bFlush = false;
//
class GUI
{
  Camera3D cameraa;
  Player p1;
  
  //stuff for displaying the different stats:
  boolean hasBeenOnGround = true; //used to determine whether or not the player has just jumped into the air.
  int inAirTimer = 0;   //used to display the longest amount of time the player has been in the air so far.
  int inAirCounter = 0; //used to count the amount of time in the air since last jump.
  float airDistanceTimer = 0; //displays longest distance in air so far
  float airDistanceCounter = 0; //counts the distance in air since last jump
  
// ____________________
GUI(Camera3D icamera, Player ip1) 
{
  cameraa = icamera;
  p1 = ip1;
  if ( RMode == OPENGL )
    Mode = OPENGL;
  size(800, 600, Mode);

  if ( Mode == OPENGL )
  {
    // enable VSync to avoid framerate problems ?
  //  PGraphicsOpenGL pgl;
   // GL gl;
   // pgl = (PGraphicsOpenGL)g; //processing graphics object
   // gl = pgl.beginGL(); //begin opengl
    //gl.setSwapInterval(1); //set vertical sync on, screen refresh is 60 Hz so framerate will be 60
   // pgl.endGL(); //end opengl
  }
  else
  {
    frameRate(60); // a little more than 60 because 60hz screen and vsync activated ?
  }

  background(10);
  fontA = loadFont("ComicSansMS-48.vlw");
  
  hasBeenOnGround = p1.grounded;
}

// ____________________
void Draw(long elapsedTime) 
{
  //background(10);

  // display framerate
  color FillColor = color(60,20,100);
  fill(FillColor);
  textFont(fontA, 40);
  text("fps         "+ (int)frameRate,                  cameraa.pos.x - cameraa.cwidth + 35, cameraa.pos.y - cameraa.cheight + 70);
  text("Health      " + p1.life,     cameraa.pos.x - cameraa.cwidth + 35, cameraa.pos.y - cameraa.cheight + 105);
   text("Air Time                 " + ((float)inAirCounter / 1000),     cameraa.pos.x - cameraa.cwidth + 35, cameraa.pos.y + cameraa.cheight - 70);
   text("Max Air Time         " + ((float)inAirTimer / 1000),     cameraa.pos.x - cameraa.cwidth + 35, cameraa.pos.y + cameraa.cheight - 35);
  text("Air Distance           " + ((float)airDistanceCounter ),     cameraa.pos.x + cameraa.cwidth - 600, cameraa.pos.y + cameraa.cheight - 70);
   text("Max Air Distance  " + ((float)airDistanceTimer ),     cameraa.pos.x+ cameraa.cwidth -600, cameraa.pos.y + cameraa.cheight - 35);
  
  ProcessInAirTimer(elapsedTime);

  //text("Viewport Mode	  = " + Mode,     cameraa.pos.x - cameraa.cwidth + 15, cameraa.pos.y - cameraa.cheight + 70);
  //text("Instruction Mode (R) = " + RMode, cameraa.pos.x - cameraa.cwidth + 15, cameraa.pos.y - cameraa.cheight + 105);
  //text("force flush (F) ? " + bFlush,     cameraa.pos.x - cameraa.cwidth + 15, cameraa.pos.y - cameraa.cheight + 140);
  
  
}


void  ProcessInAirTimer(long elapsedTime) 
 {
   if (hasBeenOnGround && !p1.grounded)
   {
     hasBeenOnGround = false;
     
   }
   else if (!hasBeenOnGround && !p1.grounded)
   {
     inAirCounter += elapsedTime;
     
      airDistanceCounter += p1.velocity.mag();
   }
   else if (!hasBeenOnGround && p1.grounded)
   {
     hasBeenOnGround = true;
     
     if (inAirCounter > inAirTimer)
       inAirTimer = inAirCounter;
       
    if (airDistanceCounter > airDistanceTimer)
       airDistanceTimer = airDistanceCounter;
       
     airDistanceCounter = 0;
     
     inAirCounter = 0;
   }
   
 }
 
// ____________________
//void Update()
//{
//  if (keyPressed)
//  {
//  if ( key == 'f' || key == 'F' )
//    bFlush = !bFlush;
//
//  if ( key == 'r' || key == 'R' )
//  {
//    if ( Mode == OPENGL )
//    {
//	if (RMode == OPENGL )
//	{
//	  RMode = P3D;
//	  println("going to P3D Rmode");
//	}
//	else if ( RMode == P3D )
//	{
//	  RMode = OPENGL;
//	  println("going to OPENGL Rmode");
//	}
//    }
//    else
//	  println("Can't switch to OpenGL instructions in P3D render mode");
//  }
//  }
//}
}
