class Planet extends Entity
{

  PImage img;
  PImage effectImg;
  float radius;  //planet has stronger or weaker gravity based on radius.
  float radiusOfEffect;
  Quad2D quadd;
  Quad2D effectQuadd;

  Planet() { quadd = new Quad2D(); effectQuadd = new Quad2D();}// img = loadImage("medmarbleplanet.png");  effectImg = loadImage("purple50.png");}
  Planet(PVector iPos, float iRadius, PImage iImg, PImage iEffectImg)
  {       
    radius = iRadius;
    
    radiusOfEffect = 250 + (radius*2);
    
    img = iImg;
    effectImg = iEffectImg;
    
    pos = iPos;
    quadd = new Quad2D(new PVector(pos.x, pos.y, 0), radius*2, radius*2);
    effectQuadd = new Quad2D(new PVector(pos.x, pos.y, 0), radiusOfEffect*2, radiusOfEffect*2);
    
    
  }

  void Update()
  {
  }
  
  void  RotatePlanet(PVector rotAxis, float rotAmount)
  {
     quadd.RotateQuad(rotAxis, rotAmount);
     
     pos = quadd.RotateVector(rotAxis, rotAmount, pos);
     
  }

  void Draw()
  {
    //effectQuadd.Draw(effectImg);
    quadd.Draw(img);
  }

  void set(Planet iPlanet)
  {
    pos.set(iPlanet.pos);
   radius = iPlanet.radius ;  //planet has stronger or weaker gravity based on radius.
  
   radiusOfEffect = iPlanet.radiusOfEffect;

   quadd.set(iPlanet.quadd);
      
   effectQuadd.set(iPlanet.effectQuadd);
  }
}

